 include "gamelib.h"
 bsr SaveAI1
 bsr StartScreen
 bsr ClearAI1
 RC ClrScr
 ;start the game
 bsr Game
 bsr RestoreAI1
 RC GKeyFlush ;so last buttons pressed won't echo to the AMS
 ;display end message
 move.w #2,-(a7)
 RC FontSetSys
 moveq #44,d0
 moveq #40,d1
 lea ES_1,a0
 bsr DrawStr_Reg
 lea -32(a7),a7
 clr.w -(a7)
 move.l FramesAlive,-(a7)
 pea ES_2
 pea 10(a7)
 RC sprintf
 lea 14(a7),a7
 moveq #80+4,d0
 move.l a7,a0
ESCenterText:
 subq.w #4,d0
 tst.b (a0)+
 bne ESCenterText
 move.l a7,a0
 moveq #50,d1
 bsr DrawStr_Reg
 lea 32(a7),a7
 RC FontSetSys
 addq.l #2,a7
ESWaitEsc:
 RC ngetchx
 cmp.w #264,d0
 bne ESWaitEsc
 rts
 include "aslib.h"
BallSprt:
 dc.b $18,$3C,$3C,$18
 even
GameSpeed:
 dc.w 75
FallupDelay:
 dc.w 4
FallupInterval:
 dc.w 15
FramesAlive:
 dc.l 0
GameFlags:
 dc.w 0 ;bit 0: practice mode
 ;       bit 1: no allow edges
 ;       bit 2: collide with top
 even
Game:
 movem.l d3-d7/a2-a6,-(a7)
 ;wait till all relevant keys aren't being pressed
WaitKeysGone:
 bsr testgamekeys
 tst.w d0
 bne WaitKeysGone
 ;draw a starter line
 moveq #-1,d0
 lea ($4C00+15*30).w,a0
 moveq #4,d1
StartLineLoop:
 move.l d0,(a0)+
 move.l d0,26(a0)
 dbra d1,StartLineLoop
 moveq #0,d3 ;ballY*64,ballX*64
 moveq #0,d4 ;speedY
 moveq #10,d6 ;loop counter
 move.w FallupDelay,d7 ;fallup phase
 move.w FallupInterval,a3 ;interval between steps
 move.l a3,a2 ;interval counter
 clr.l FramesAlive
GameLoop:
 addq.l #1,FramesAlive
 ;draw ball
 bsr DrawBall
 ;wait for next frame
 moveq #0,d5
 moveq #0,d6
WaitLoop:
 bsr testgamekeys
 or.w d0,d5
 addq.w #1,d6
 cmp.w GameSpeed,d6
 blt WaitLoop
WLEnd:
 ;clear ball
 bsr DrawBall
 subq.w #1,d7
 bge FDPNo
 move.w FallupDelay,d7
 bsr ScrollDown
 addq.w #1,a2
 cmp.w a3,a2
 ble FDPNo
 suba.l a2,a2
 lea ($4C00).w,a0
 bsr DrawNewSteps
FDPNo:
 bsr ChkJump
 add.w d4,d3 ;add speedY
 addq.w #1,d4 ;gravity
 swap d3
 btst #1,d5
 beq NoLeft
 sub.w #70,d3
NoLeft:
 btst #3,d5
 beq NoRight
 add.w #70,d3
NoRight:
 ;check bounds and adjust ball speed accordingly (d3 is in its X phase)
 tst.w d3
 bge NoXZero
 clr.w d3
NoXZero:
 cmp.w #152*64,d3
 ble NoXEnd
 move.w #152*64,d3
NoXEnd:
 swap d3
 tst.w d3
 bge NoYZero
 clr.w d3
 clr.w d4
NoYZero:
 cmp.w #96*64,d3
 ble NoYEnd
 btst #0,GameFlags+1
 beq GameEnd
 move.w #96*64,d3
 clr.l d4
NoYEnd:
 ;check for escape to see if exit is necessary
 btst #8,d5
 beq GameLoop
GameEnd:
 movem.l (a7)+,d3-d7/a2-a6
 rts
DrawBall:
 move.l d3,d2
 moveq #0,d0
 moveq #0,d1
 lsr.l #6,d2
 move.b d2,d1
 swap d2
 move.b d2,d0
 moveq #4,d2
 lea BallSprt,a0
 lea ($4C00).w,a1
 bra Sprite8
keymoveball:
 btst #0,d5
 beq kl1
 subq.w #1,d3
kl1:
 btst #2,d5
 beq kl2
 addq.w #1,d3
kl2:
 swap d3
 btst #1,d5
 beq kl3
 subq.w #1,d3
kl3:
 btst #3,d5
 beq kl4
 addq.w #1,d3
kl4:
 swap d3
 rts
ChkJump:
;check the collide with top bit
 btst.b #2,GameFlags+1
 bne DoTopBit
 tst.w d4
 blt NoJump
DoTopBit:
;see if you're at the bottom
 cmp.w #96*64,d3
 bge DoJump
;see if you are on a line platform
 move.w d3,d0
 lsr.w #6,d0 ;scale factor
 tst.w d4
 blt CNoDown1
 addq.w #4,d0 ;to get to bottom
CNoDown1:
 mulu.w #30,d0
 lea $4C00,a0
 adda.l d0,a0
 swap d3
 move.w d3,d0
 swap d3
 lsr.w #6,d0 ;scale factor
 addq.w #2,d0
 moveq #3,d2 ;number of bits to scan -1
 tst.w d4
 bgt CNoUp1
 moveq #1,d2
 addq.w #1,d0 ;to get to first point
CNoUp1:
 move.w d0,d1
 lsr.w #3,d0 ;bytewidth
 adda.w d0,a0
 not.w d1
 and.w #7,d1
 lea 30(a0),a1
 ;a0:d1 is the first point to test
ChkJmp_TstBit:
 btst.b d1,(a0)
 bne DoJump
 btst.b d1,(a1)
 bne DoJump_FixBallLoc
 subq.w #1,d1
 bge ChkJmp_NoNewByte
 moveq #7,d1
 addq.l #1,a0
 addq.l #1,a1
ChkJmp_NoNewByte:
 dbra d2,ChkJmp_TstBit
 bra NoJump
DoJump_FixBallLoc:
 add.w #64,d3
DoJump:
 move.w d4,d0
 moveq #0,d4
 tst.w d0
 blt NoJump
 btst #4,d5
 beq NoJump
 moveq #-55,d4
NoJump:
 rts
ScrollDown:
 lea ($4C00+100*30).w,a0 ;dest
 lea ($4C00+99*30).w,a1 ;src
 move.w #1484,d0
scrdownloop:
 move.w -(a1),-(a0)
 dbra d0,scrdownloop
 moveq #14,d0
scrdownloop2:
 clr.w (a1)+
 dbra d0,scrdownloop2
 rts
DrawNewSteps:
 move.w randnum+2,d0
 move.w #1023,d2
 moveq #120,d1
 and.w d2,d0
 bne NoBlank
 move.w d1,d0 ;just a little thing in the middle to prevent an impossibility
NoBlank:
 cmp.w d2,d0
 bne NoBlock
 move.w d1,d0 ;just a little thing in the middle to prevent an impossibility
NoBlock:
 ;each "sector" is 16 pixels wide, so we will use 10 random bits (except for when no edges are blacked)
 moveq #9,d1
 btst.b #1,GameFlags+1
 beq DNS_Loop
 moveq #7,d1
 addq.l #2,a0
DNS_Loop:
 moveq #0,d2
 btst d1,d0
 beq NoSet
 moveq #-1,d2
NoSet:
 move.w d2,(a0)+
 move.w d2,28(a0)
 dbra d1,DNS_Loop
 rts
StartScreen:
 move.l d3,-(a7)
 move.l d4,-(a7)
 move.l a2,-(a7)
 moveq #4,d3
 moveq #5,d4
 RC ClrScr
 move.w #2,-(a7) ;F_8x10
 RC FontSetSys
 ext.w d0
 move.w d0,(a7)
 moveq #0,d0
 moveq #0,d1
 lea SS_1,a0
 bsr DrawStr_Reg
 moveq #16,d0
 moveq #15,d1
 lea SS_2a,a0
 bsr DrawStr_Reg
 moveq #60,d0
 moveq #25,d1
 lea SS_2b,a0
 bsr DrawStr_Reg
 move.w #1,-(a7) ;F_6x8
 RC FontSetSys
 addq.l #2,a7
 lea SS_3,a0
 bsr DrawStrList
 lea SS_5+22,a2
 move.l #'Off ',(a2)
SS_Keyloop:
 ;draw speed text
 lea -32(a7),a7
 clr.w -(a7)
 move.w d4,-(a7)
 pea SS_4
 pea 8(a7)
 RC sprintf
 lea 12(a7),a7
 moveq #5,d0
 moveq #82,d1
 move.l a7,a0
 bsr DrawStr_Reg
 lea 32(a7),a7
 moveq #5,d0
 moveq #92,d1
 lea -22(a2),a0
 bsr DrawStr_Reg
 ;check key
 RC ngetchx
 cmp.w #265,d0 ;KEY_APPS
 bne NoTogglePrac
 move.l #'On  ',(a2)
 bchg #0,d3
 beq SS_Keyloop ;if it was just set to one
 move.l #'Off ',(a2)
 bra SS_Keyloop
NoTogglePrac:
 sub.w #340,d0
 bne SS_T1
 subq.w #1,d4
 bgt SS_Keyloop
 moveq #10,d4
 bra SS_Keyloop
SS_T1:
 addq.w #3,d0
 bne SS_T2
 addq.w #1,d4
 cmp.w #10,d4
 ble SS_Keyloop
 moveq #1,d4
 bra SS_Keyloop
SS_T2:
 RC FontSetSys
 addq.l #2,a7
 move.w d3,GameFlags
 move.l #375*5/3,d0
 divu.w d4,d0
 move.w d0,GameSpeed
 move.l (a7)+,a2
 move.l (a7)+,d4
 move.l (a7)+,d3
 rts
SS_1:
 dc.b 'FallUp by Joey Adams',0
SS_2a:
 dc.b 'Press Any Key to',0
SS_2b:
 dc.b 'Start',0
SS_3:
 dc.w 5 ;count
 dc.w 5,35 ;start coordinate
 dc.w 8 ;height
 dc.b 'Keys:',0
 dc.b '2nd  Jump',0
 dc.b '    Move left',0
 dc.b '    Move right',0
 dc.b 'ESC  Quit',0
 even
SS_4:
 dc.b 'Speed (,): %d  %c',0
 even
SS_5:
 dc.b 'Practice Mode (APPS): OFF ',0
ES_1:
 dc.b 'Game Over',0
ES_2:
 dc.b 'Score: %ld%c',0
 even
 